﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ShredTheLog.Api.DataContracts.TextChat;
using ShredTheLog.Api.DataContracts;

namespace ShredTheLog.Api
{
    public interface INotificationSource<T> : ISubject<T>
    {
    }

    public interface IMessageNotificationSource : INotificationSource<IAddMessageUpdate>
    {
    }

    public interface ILoginNotificationSource : INotificationSource<ISessionCredentials>
    {
    }

    public interface INotifier : IDisposable
    {
        void Start();
    }

    public interface INotifierSettingsViewModel
    {
        void Save();
    }
}
