﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ShredTheLog.Common.MVVM;

namespace ShredTheLog.Controls
{
    public class ColorPicker : ControlBase
    {
        static ColorPicker()
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(ColorPicker), new FrameworkPropertyMetadata(typeof(ColorPicker)));
        }

        public ColorPicker()
        {
            BrowseCommand = new DelegateCommand(
                () =>
                {
                    var dlg = new System.Windows.Forms.ColorDialog() 
                    { 
                        Color = System.Drawing.Color.FromArgb(Value.A, Value.R, Value.G, Value.B) 
                    };
                    if (dlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                        Value = Color.FromArgb((byte)dlg.Color.A, (byte)dlg.Color.R, (byte)dlg.Color.G, (byte)dlg.Color.B);
                }, () => !IsReadOnly);
        }

        public Color Value
        {
            get { return (Color)GetValue(ValueProperty); }
            set { SetValue(ValueProperty, value); }
        }
        public static readonly DependencyProperty ValueProperty = DependencyProperty.Register("Value", typeof(Color), typeof(ColorPicker));

        public ICommand BrowseCommand
        {
            get { return (ICommand)GetValue(BrowseCommandProperty); }
            set { SetValue(BrowseCommandProperty, value); }
        }
        public static readonly DependencyProperty BrowseCommandProperty = DependencyProperty.Register("BrowseCommand", typeof(ICommand), typeof(ColorPicker));
    }
}
