﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;
using ShredTheLog.Api;
using System.ComponentModel.Composition;
using System.Diagnostics.Contracts;

namespace ShredTheLog.Converters
{
    [ValueConversion(typeof(string), typeof(string))]
    public sealed class LocalizedStringConverter : ConverterBase, IValueConverter
    {
        [Import]
        private IShredServices ShredServices { get; set; }

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            var key = (string)value;
            Contract.Assume(!String.IsNullOrWhiteSpace(key));
            return ShredServices.GetLocalizedString(key);
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotSupportedException();
        }

        public static readonly LocalizedStringConverter Default = new LocalizedStringConverter();
    }
}
