﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;
using System.ComponentModel.Composition;
using ShredTheLog.Api;

namespace ShredTheLog.Converters
{
    [ValueConversion(typeof(Language?), typeof(object))]
    public sealed class NullableLanguageConverter : ConverterBase, IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            var v = (Language?)value;
            return v.HasValue ? (object)v.Value : (object)new NullValue();
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value is Language)
                return (Language?)value;
            else if (value is NullValue)
                return (Language?)null;
            else
                throw new NotSupportedException();
        }

        public static readonly NullableLanguageConverter Default = new NullableLanguageConverter();
    }
}
