﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using System.Net;

namespace ShredTheLog.Model
{
    public class LoginException : ApplicationException
    {
        public LoginException()
            : base("Login failed.")
        {
        }

        public LoginException(string message)
            : base(message)
        {
        }
    }

    public sealed class FullBanException : LoginException
    {
        public FullBanException()
            : base("Login failed: user has been banned.")
        {
        }
    }

    public sealed class UserDeletedException : LoginException
    {
        public UserDeletedException()
            : base("Login failed: user has been deleted.")
        {
        }
    }

    public sealed class InvalidCredentialsException : LoginException
    {
        public InvalidCredentialsException()
            : base("Login failed: user name or password is incorrect.")
        {
        }
    }
}
