﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ShredTheLog.Common.MVVM;
using System.Windows.Input;
using System.Diagnostics.Contracts;
using System.ComponentModel.Composition;
using ShredTheLog.Api;
using ShredTheLog.Api.DataContracts;
using ShredTheLog.Api.DataContracts.TextChat;

namespace ShredTheLog.ViewModels
{
    public class CommandViewModel : ViewModelBase
    {
        public string NameResourceId { get; private set; }
        public ICommand Command { get; private set; }

        public CommandViewModel(string nameResourceId, ICommand command)
        {
            Contract.Requires(!String.IsNullOrEmpty(nameResourceId));
            Contract.Requires(command != null);

            NameResourceId = nameResourceId;
            Command = command;
        }
    }
}
